import { BaseBatchDeleteManager } from 'src/core/modules/domain/usecase/managers/base-batch-delete.manager';
import { VipCategoryEntity } from '../../entities/vip-category.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { VipCategoryModel } from '../../../data/models/vip-category.model';
import { VipCategoryDeletedEvent } from '../../entities/event/vip-category-deleted.event';
import { BatchResult } from 'src/core/response/domain/ok-response.interface';
import { Injectable } from '@nestjs/common';

@Injectable()
export class BatchDeleteVipCategoryManager extends BaseBatchDeleteManager<VipCategoryEntity> {
  async beforeProcess(): Promise<void> {
    return;
  }

  async validateData(data: VipCategoryEntity): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return VipCategoryModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: VipCategoryDeletedEvent,
      },
    ];
  }

  getResult(): BatchResult {
    return this.result;
  }
}
